# propertylist.rb

class Propertylist
	
	require 'osx/cocoa'
	include OSX
	
	def self.isPropertyList(obj)
		if obj.isKindOfClass NSString.objc_send(:class)
			return true
		end
		
		if obj.isKindOfClass NSData.objc_send(:class)
			return true
		end
		
		if obj.isKindOfClass NSArray.objc_send(:class)
			obj.each do |currentObj|
				next if isPropertyList(currentObj)
				
				return false
			end
			
			return true
		end
		
		if obj.isKindOfClass NSDictionary.objc_send(:class)
			return false unless isPropertyList(obj.allKeys)
			return false unless isPropertyList(obj.allValues)
			
			return true
		end
		
		return false
	end
	
	def self._propertyList_ascii(obj)
		if obj.isKindOfClass NSString.objc_send(:class)
			return "\"#{obj}\""
		end
		
		if obj.isKindOfClass NSArray.objc_send(:class)
			encodedObjects = NSMutableArray.array
			
			obj.each do |currentObj|
				encodedObjects.addObject _propertyList_ascii(currentObj)
			end
			
			encodedObjectsString = encodedObjects.componentsJoinedByString(",")
			return "(#{encodedObjectsString})"
		end

		if obj.isKindOfClass NSDictionary.objc_send(:class)
			encodedObject = "{"
			
			obj.each do |currentKey, currentValue|
				encodedObject << "#{_propertyList_ascii(currentKey)} = #{_propertyList_ascii(currentValue)};"
			end
			
			encodedObject << "}"
			return encodedObject
		end
		
		
		raise "unknown type to encode for ASCII property list #{obj.objc_send(:class)}"
		return nil
	end
	
	def self.encodePropertyList(obj = nil, format = :ascii)
		raise "obj must not be nil" if obj.nil?
		raise "unknown class for property list encoding #{obj.objc_send(:class)}" unless isPropertyList(obj)
		raise "unknown encoding type #{format}" unless format == :ascii
		
		return _propertyList_ascii(obj)
	end
	
end
